c *************************************************************
      subroutine bbgaus(x,gg)
c   computes normal probability integral gg from -(infinity) to xx
c    sets gg=1 if xx < -6;  gg=0  if xx > +6
c   uses approximation Handbook of Mathematical Functions-
c   NBS Applied Math Series 55--p299 7.1.26 for error function
      ax=abs(x)/1.4142136
      if(ax-4.2426408) 20,20,10
   10 gg=0.
      if(x.lt.0) gg=+1.
      return
   20 continue
      d=1.+(((((4.30638e-5*ax+2.765672e-4)*ax+1.520143e-4
     & )*ax+9.2705272e-3)*ax+4.2282012e-2)*ax+7.0523078e-2)*ax
      d=d*d
      d=d*d
      d=d*d
      gg=.5/(d*d)
      if(x) 30,30,40
   30 gg=1.-gg
   40 return
      end
