c **************************************************************
      subroutine cldis(x,y,jl)
c     subroutine to compute shortest distance, etc to line
c     containing fault segment i of jl th fault (for each i)
c     determines whether closest point to fault is at
c     low end (min(i)=2)
c     interior  (min(i)=3)
c     high end  (min(i)=1)
c     set isid=0 if multiple turning points
c         isid=1 if single closest distance from site to fault
c         interior to fault
c         isid=2 if closest distance from site to fault at one end
c         of the fault
      dimension dlp(20)
      common/linps/distl(24,26),disq(24,26),jseg,jsegm,
     & xl(24,26),yp(24,26),coa(24,26),sia(24,26)
      common/extra/isid,shdis,dist(24),inear
      common /lindis/dls(24),perp(24),min(24),persq(24)
      shdis=1.e9
      do 10 ii=1,jsegm
   10 dist(ii)=distl(ii,jl)
      i1=0
      i2=0
      i3=0
      isid=0
      do 20 i=1,jseg
      slsq=(x-xl(i,jl))**2+(y-yp(i,jl))**2
      if(slsq.lt.shdis) shdis=slsq
   20 continue
      do 50 i=1,jsegm
      xd=x-xl(i,jl)
      yd=y-yp(i,jl)
      perp(i)=-xd*sia(i,jl)+yd*coa(i,jl)
      dls(i)=xd*coa(i,jl)+yd*sia(i,jl)
      persq(i)=perp(i)*perp(i)
      if(dls(i).lt.0) go to 30
      if(dls(i).le.dist(i)) go to 40
c      shortest distance external to segment
      min(i)=1
      i1=i1+1
      dlp(i)=dls(i)-dist(i)
      go to 50
   30 min(i)=2
      i2=i2+1
      go to 50
   40 min(i)=3
      i3=i3+1
      if(persq(i).lt.shdis) shdis=persq(i)
      dlp(i)=0.
   50 continue
      if(i1.ne.jsegm)  go to 90
      iup=jsegm
      isid=2
   60 iuh=iup/2
      if(2*iuh.ne.iup) dls(iuh+1)=-dlp(iuh+1)
      if(iup.eq.1)  go to 80
      j=iup
      do 70 i=1,iuh
      t=persq(i)
      persq(i)=persq(j)
      persq(j)=t
      dls(i)=-dlp(j)
      dls(j)=-dlp(i)
      t=dist(i)
      dist(i)=dist(j)
      min(i)=2
      min(j)=2
      dist(j)=t
   70 j=j-1
   80 return
   90 if(i2.ne.jsegm)  go to 100
      isid=2
      return
  100 if(i3.gt.1) return
      if(min(1).eq.2) return
      iturn=0
      iq=1
      do 110 k=1,jsegm
      if(min(k).ne.1) go to 120
      iturn=iturn+1
  110 continue
  120 if(iturn.ne.i1) return
      if(i3.eq.1 .and. min(k).eq.2) return
c   we have single turning point
      isid=1
      inear=k-1
      if(min(k).ne.3) go to 140
      inear=k
c      adjust to 2 sep segments
      j=jseg
      do 130 i=k,jsegm
      dls(j)=dls(j-1)
      persq(j)=persq(j-1)
      dist(j)=dist(j-1)
  130 j=j-1
      jsegm=jseg
      jseg=jseg+1
      dist(k+1)=dist(k+1)-dls(k)
      dist(k)=dls(k)
      dls(k+1)=0
  140 iup=inear
      go to 60
      end
