c **************************************************************
      subroutine inieqr(x1,y1,x2,y2)
c    read xlong, ylat in radians for 1st point
c    read xlong, ylat in radians for 2nd point
c    points 1 and 2 to be transformed to equator
c    point 1 will be transformed to (0,0)
c    point 2 will be transformed to (d,0)
c   where d=great circle distance between (x1,y1) and (x2,y2)
c    output is transformation matrices f (forward) fi (backward)
c      generated and stored in common
      common/eqr/ r1(3,3),r2(3,3),r3(3,3),d(3,3),f(3,3),vec(3)
      common/inv/fi(3,3),res(3)
      cp1=cos(y1)
      cp2=cos(y2)
      cl1=cos(x1)
      sp1=sin(y1)
      sp2=sin(y2)
      sl1=sin(x1)
c  initialize matrices
      do 10 i=1,3
      do 10 j=1,3
      r1(i,j)=0.
      r2(i,j)=0.
   10 r3(i,j)=0.
      r1(1,1)=1.
      r2(2,2)=1.
      r3(3,3)=1.
      r2(1,1)=cp1
      r2(3,3)=cp1
      r2(1,3)=sp1
      r2(3,1)=-sp1
      r3(1,1)=cl1
      r3(2,2)=cl1
      r3(1,2)=sl1
      r3(2,1)=-sl1
      s1=cp1*sp2-sp1*cp2*cos(x2-x1)
      c1=cp2*sin(x2-x1)
      den=sqrt(c1*c1+s1*s1)
      sinth=s1/den
      costh=c1/den
      r1(2,2)=costh
      r1(3,3)=costh
      r1(2,3)=sinth
      r1(3,2)=-sinth
      call matmpy(r1,r2,d)
      call matmpy(d,r3,f)
c   transformation matrix in f] inverse matrix in fi
c   compute inverse
      do 20 i=1,3
      do 20 j=1,3
      r1(i,j)=0.
      r2(i,j)=0.
      r3(i,j)=0.
   20 continue
      r1(3,3)=1.
      r2(2,2)=1.
      r3(1,1)=1.
      r1(1,1)=cl1
      r1(2,2)=cl1
      r1(2,1)=sl1
      r1(1,2)=-sl1
      r2(1,1)=cp1
      r2(3,3)=cp1
      r2(1,3)=-sp1
      r2(3,1)=sp1
      r3(2,2)=costh
      r3(3,3)=costh
      r3(3,2)=sinth
      r3(2,3)=-sinth
      call matmpy(r1,r2,d)
      call matmpy(d,r3,fi)
      return
      end
