c **************************************************************
      subroutine inside(xnot,ynot,isub,r,pangle)
      common/xyarea/xsav(2,50),ysav(2,50),sarea(50)
      common/inout/ic,ics,ifar,azimf,stsize,stepo
      common/slinds/dls(4),perp(4),sl1(4),slsq(4),min(4),persq(4)
     &,srsq(4),dlp(4)
      common/slinp/aa(4,50),bb(4,50),cc(4,50),rta(4,50),dist(4,50),
     & disq(4,50)
      common/xlyl/xl(4),yl(4),xr(4),yr(4),xc(4),yc(4)
      dimension jsub(3)
c
c     (xmid,ymid)=point inside quadrilateral source region ii
c     r=radius of circle (or radius of annular ring of width dr)
c     centered at (xmid,ymid)
c     ii = index identifying quadrilateral source region
c
c    the area contained in the intersection of the region and annular
c     ring is determined by the fraction of the ring within the region.
c            area = pangle x r x dr
c     where pangle = the angle (in radians) subtended by the
c     part of the annular ring contained within the region.
c     subroutine insid determines pangle.
c
c       adapted from subroutine by mcguire
      data pi,pi2/3.1415927,6.2831853/
      data jsub/2,3,1/
      rsq=r*r
      npt=0
      angle=0.
c         loop on each side
      do 110 ii=1,4
      if(min(ii)-2) 10,40,70
c     closest point is xr(ii),yr(ii)
c       at most one intersection
   10 if(rsq.gt.slsq(ii)) go to 110
      if(rsq.lt.srsq(ii)) go to 110
      d=(sqrt(rsq-persq(ii))-dlp(ii))/dist(ii,isub)
   20 y1=(yl(ii)-yr(ii))*d+yr(ii)
      x1=(xl(ii)-xr(ii))*d+xr(ii)
c  intersects in range
c          does circle (radius r) intersect it?
c        store first point
   30 npt=npt+1
      xc(npt)=x1
      yc(npt)=y1
      go to 110
c   closest point is at xl(ii),yl(ii)
   40 if(rsq.lt.slsq(ii)) go to 110
      if(rsq.gt.srsq(ii)) go to 110
   50 d=(sqrt(rsq-persq(ii))+dls(ii))/dist(ii,isub)
   60 x1=xl(ii)+(xr(ii)-xl(ii))*d
      y1=yl(ii)+(yr(ii)-yl(ii))*d
      go to 30
   70 if(rsq.lt.persq(ii)) go to 110
      if(rsq.le.slsq(ii)) go to 80
      if(rsq.gt.srsq(ii)) go to 110
c   single intersection
c     on side nearer xr,yr
      go to 50
   80 if(rsq.gt.srsq(ii)) go to 90
c     two intersections on this side
c    can compute angle directly without determining coordinates
      arg=abs(perp(ii))/r
      as=acos(arg)
      go to 100
   90 d=(dls(ii)-sqrt(rsq-persq(ii)))/dist(ii,isub)
      go to 60
c    single intersection
c          both points are on boundary, calculate angle betwen them.
  100 angle=2.*as + angle
c        see if second point only is on boundary
  110 continue
      if (npt) 570,120,140
  120 if (angle-0.001) 570,130,130
c        following is for case of no single intersection points;
c        angle is 2 * pi - angle calculated so far.
  130 pangle=pi2-angle
      go to 560
  140 go to (570,230,150,500),npt
c     this is an error unless radius is on a vertex and
c      was counted twice.
  150 do 160 i=1,3
      j=jsub(i)
      if(abs(xc(i)-xc(j)) .ge. .01) go to 160
      if(abs(yc(i)-yc(j)) .le. .01) go to 210
  160 continue
c   check for one of three points being a vertex
      do 200 i=1,4
      do 170 j=1,3
      if(abs(xc(j)-xl(i)).le. .001) go to 170
      if(abs(yc(j)-yl(i)) .gt. .001) go to 180
  170 continue
      go to 200
  180 if(j-2) 190,190,220
  190 xc(j)=xc(3)
      yc(j)=yc(3)
      go to 220
  200 continue
      go to 570
  210 if(i.ne.1) go to 220
      xc(2)=xc(3)
      yc(2)=yc(3)
  220 npt=2
      go to 230
c         2 intersection points; determine azimuths.
  230 if (xc(1)-xnot-r) 260,250,240
  240 if (xc(1)-xnot-r-0.001) 250,250,570
  250 azim1=0.0
      go to 300
  260 if (xc(1)-xnot+r) 270,280,290
  270 if (xc(1)-xnot+r+0.001) 570,280,280
  280 azim1=pi
      go to 320
  290 azim1=acos((xc(1)-xnot)/r)
  300 if (yc(1)-ynot) 310,320,320
  310 azim1=pi2  - azim1
  320 if (xc(2)-xnot-r) 350,340,330
  330 if (xc(2)-xnot-r-0.001) 340,340,570
  340 azim2=0.0
      go to 390
  350 if (xc(2)-xnot+r) 360,370,380
  360 if (xc(2)-xnot+r+0.001) 570,370,370
  370 azim2=pi
      go to 410
  380 azim2=acos((xc(2)-xnot)/r)
  390 if (yc(2)-ynot) 400,410,410
  400 azim2=pi2 -azim2
  410 pangle=azim2-azim1
      if (pangle) 420,570,460
  420 if (azim1-azimf) 430,570,440
  430 pangle=pi2 +pangle -angle
      go to 560
  440 if (azimf-azim2) 430,570,450
  450 pangle=-pangle-angle
      go to 560
  460 if (azim2-azimf) 470,570,480
  470 pangle=pi2 -pangle -angle
      go to 560
  480 if (azimf-azim1) 470,570,490
  490 pangle=pangle-angle
      go to 560
c        four intersection points (each on a different side).
c        determine angle by finding closest 2 intersections to
c        farthest corner, calculate angle betwen, and add angle
c        between other two intersections.
  500 dist1=10000000.
      i1=0
      i2=0
      i3=0
      i4=0
      do 550 jj=1,4
      distn=(xl(ifar)-xc(jj))*(xl(ifar)-xc(jj))
     &   +(yl(ifar)-yc(jj))*(yl(ifar)-yc(jj))
      if (distn-dist1) 510,510,520
  510 dist2=dist1
      dist1=distn
      i4=i3
      i3=i2
      i2=i1
      i1=jj
      go to 550
  520 if(distn-dist2) 530,530,540
  530 dist2=distn
      i4=i3
      i3=i2
      i2=jj
      go to 550
  540 i4=i3
      i3=jj
  550 continue
c        calculate angle between 2 closest points to farthest corner
      ad=sqrt((xc(i1)-xc(i2))*(xc(i1)-xc(i2))
     &  + (yc(i1)-yc(i2))*(yc(i1)-yc(i2)))
      pangle=2.*asin(ad/(2.*r))
c         calculate angle between 2 farthest points from
c         farthest corner and add to previous angle.
      ad=sqrt((xc(i3)-xc(i4))*(xc(i3)-xc(i4))
     & + (yc(i3)-yc(i4))*(yc(i3)-yc(i4)))
      pangle=2.*asin(ad/(2.*r))+pangle
c       angle for this radius is now known, calculate risk
  560 return
c     anarea=pangle*r*stsize
c          error printout
  570 write (16,580) isub,ifar,npt,xnot,ynot,(xl(i),yl(i), i=1,4),r,
     &pangle,(xc(i),yc(i),i=1,4)
  580 format (' ***** error in subroutine inside. source no.',
     & i3,' debug values follow......',/10x,2i10,10(/10x,2f12.6))
  590 call exit
      end
