c ***************************************************************
      subroutine linint(reg,t,sol)
c     calculates acceleration "sol" that has probability
c     "prob" of not being exceeded during "t" years at
c     site.
c     expected yearly accelerations in the range
c     ac(j-1) < a < ac(j) are in reg(j).
c     linint is called from subroutine out.
      common/tims/dummy(42),iprint
      common/quad/maxp,ac(105),dumlog,aclog(105)
      common/ext/prob,ex,exl
      dimension reg(106)
      ii=maxp-1
      sum=0.
   10 if(ii.le.2) go to 20
      if(reg(ii).gt.0.) go to 40
      ii=ii-1
      go to 10
   20 sol=0.
      if(iprint.le.2) write(16,30)
   30 format(' sol not obtained for time='f7.0)
      return
   40 sum=sum+reg(ii)
      if(t*sum.gt.ex) go to 50
      ii=ii-1
      if(ii.ge.2) go to 40
      go to 20
   50 if(sum.eq.reg(ii)) go to 70
      y2=alog(t*(sum-reg(ii)))
      y1=alog(t*sum)
      exlt=exl
   60 a=(y1-y2)/(ac(ii-1)-ac(ii))
      b=y1-a*ac(ii-1)
      sol=(exlt-b)/a
      return
   70 y1=t*sum
      y2=0.
      exlt=ex
      if(iprint.le.2) write(16,80)
   80 format(' log interpolation fails--use linear')
      go to 60
      end
