/* linkuw takes a file of uw format A cards and
finds the average moment-weighted location, magnitude,
and origin time.

Currently uses the U. of W. "A" card format.
User is responsible for having consistent magnitude type
in the magnitude column. -l and -b options specify ML and mb,
program converts magnitudes to Mw.
If starting year is 18xx, use -c option.
R. LaForge 4/95
*/
 
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#define MAXCLUS	50

void abdays();

int modays[] = {31,28,31,30,31,30,31,31,30,31,30,31};
int cudays[] = {0,31,59,90,120,151,181,212,243,273,304,334,365};
int culdays[] = {0,31,60,91,121,152,182,213,244,274,305,335,366};
int yrx,monx,dayx,startyear=1900;
float avtim;

main(){
     char line2[90],c1[3],c2[3],c3[3],c4[3],c5[3];
	char c6[4],c7[4],c8[4],c9[4],c10[4],c11[4];
	float mwf2,xp;
	float day,hr,min;
	float latdeg,latmin,latpt,londeg,lonmin,lonpt;
	float lat2,lon2;
	float fppart,avlat,avlon,wt,newmag;
	float sumlat=0.,sumlon=0.,sumwt=0.,sumtim=0.;
	float time2;
	int startyear=1900,year2,lpdays;
	int yr2,mon,n=0;
	int ilat,ilatmin,ilatpt,ilon,ilonmin,ilonpt,itim,hrx,minx;

c1[2]='\0';c2[2]='\0';c3[2]='\0';c4[2]='\0';c5[2]='\0';
c6[2]='\0';c7[2]='\0';c8[2]='\0';c9[3]='\0';c10[2]='\0';c11[2]='\0';


	while(fgets(line2,sizeof line2,stdin) != NULL){
	sscanf(line2,"%*2c%2c%2c%2c%2c%2c%*7c%2c%*1c%2c%2c\
%*1c%3c%*1c%2c%2c%*8c%f",\
c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,&mwf2);

year2=atoi(c1);mon=atoi(c2);day=atof(c3);hr=atof(c4);
min=atof(c5);latdeg=atof(c6);latmin=atof(c7);latpt=atof(c8);
londeg=atof(c9);lonmin=atof(c10);lonpt=atof(c11);

	n++;

/* printf("year2= %d mon= %d day= %4.1f hr= %4.1f min= %4.1f latdeg= %4.1f\
 latmin= %4.1f latpt= %4.1f\n\
londeg= %4.1f lonmin= %4.1f lonpt= %4.1f mwf2= %3.1f\n\n",\
year2,mon,day,hr,min,latdeg,latmin,latpt,londeg,lonmin,lonpt,mwf2); */

/* get absolute time in days since startyear (1800) */

	yr2=year2+1900;
	time2=(yr2-startyear)*365+cudays[mon-1]+day+hr/24+min/1440;

/* add a day for each leap year since 1900
	and subtract a day if current year is a leap year but month
	is January or February */

	lpdays=0;
	if(yr2>1904)lpdays=(yr2-startyear-1)/4-1;
	else lpdays=(yr2-startyear)/4-1;
	time2 += lpdays;
	if((yr2 % 4 == 0 && yr2 % 100 != 0) || yr2 % 400 == 0){
		lpdays++;
		if(mon>2)time2 += 1;
		}
	
	lat2=latdeg + latmin/60 + latpt/6000;
	lon2=londeg + lonmin/60 + lonpt/6000;
			xp=1.5*mwf2+16.1;
			wt=pow(10,xp);
			sumwt += wt;
			sumlat += wt*lat2;
			sumlon += wt*lon2;
			sumtim += wt*time2;
		}
		avlat=sumlat/sumwt;
		avlon=sumlon/sumwt;
		avtim=sumtim/sumwt;
		abdays();
		itim=avtim;
		fppart=(avtim-itim)*24;
		hrx=fppart;
		fppart -= hrx;
		minx=fppart*60;
		newmag=.667*log10(sumwt)-10.7;
		ilat=avlat;
		fppart=(avlat-ilat)*60;
		ilatmin=fppart;
		fppart -= ilatmin;
		ilatpt=fppart*100;
		ilon=avlon;
		fppart=(avlon-ilon)*60;
		ilonmin=fppart;
		fppart -= ilonmin;
		ilonpt=fppart*100;
		printf("AE%2d%2d%2d%2d%2d       %2dN%2d%2d %3dW%2d%\
2d        %3.1f\n",yrx,monx,dayx,hrx,minx,ilat,ilatmin,ilatpt,ilon,\
			ilonmin,ilonpt,newmag);
	}

void abdays(){
	int i,inyear,lpdays2,invertime,remain,lp;

	lpdays2=0;
	inyear=avtim/365-1;
	invertime=inyear*365;
	yrx=inyear+startyear;

	if(yrx>1904)lpdays2=(yrx-startyear-1)/4-1;
	else lpdays2=(yrx-startyear)/4-1;
	invertime += lpdays2;
	while(1){  	/* see if year is correct */
	if((yrx % 4 == 0 && yrx % 100 != 0) || yrx % 400 == 0){
	lp=1;
	invertime += 366;
	if(invertime>=avtim){
		invertime -= 366;break;
		}}
	else{ invertime += 365;
	if(invertime>=avtim){
		lp=0;
		invertime -= 365;
		break;
		}}
	yrx++;
	}

	remain=avtim-invertime;

	for(i=1;i<13;i++){  /* find correct month */
	if(lp == 0){
	if(remain > cudays[i-1] && remain <= cudays[i]){
		monx=i;
		remain -= cudays[i-1]; break;
		}
	}else{
	if(remain > culdays[i-1] && remain <= culdays[i]){
		monx=i; remain -= culdays[i-1]; break;
	}}}

	dayx=remain;
	yrx -= startyear;
	if(yrx >= 100)yrx -= 100;

	/*printf(" yr= %d mon= %d day= %d\n",yrx,monx,dayx); */
}
