c ************************************************************
      subroutine outsid(xnot,ynot,isub,r,angle)
      common/inout/ic,ics,ifar,azimf,stsize
      common/xysav/xsav(2,50),ysav(2,50),sarea(50)
       common/xlyl/xl(4),yl(4),xr(4),yr(4), xc(4),yc(4)
       common/slinp / aa(4,50),bb(4,50),cc(4,50),rta(4,50),dist(4,50)
     &,disq(4,50)
      common/slinds/dls(4),perp(4),sl1(4),slsq(4),min(4),persq(4)
     &,srsq(4),dlp(4)
      dimension jsub(3)
c     subroutine for calculating angle when site is outside
c          (quadrilateral) source area.
c      r is the radial distance for which angle is sought
c
c     (xnot,ynot)=point outside quadrilateral source region isub
c     r=radius of circle (or radius of annular ring of width dr)
c     centered at (xnot,ynot)
c     isub = index identifying quadrilateral source region
c
c    the area contained in the intersection of the region and annular
c     ring is determined by the fraction of the ring within the region.
c            area = angle x r x dr
c     where angle = the angle (in radians) subtended by the
c     part of the annular ring contained within the region.
c
c          (rc is closest distance between site and source.)
c          (rf is furthest distance between site and source)
c       subroutine csqdis has computed distance to vertices of subregion
c       and shortest distance to each side
c       adapted from subroutine by mcguire
c
      data jsub/2,3,1/
      npt=0
      angle=0.
      signal=1.
c        loop on each side
      rsq=r*r
      do 140 ii=1,4
      if(min(ii)-2) 10,40,70
c     closest point is xr(ii),yr(ii)
c       at most one intersection
   10 if(rsq.gt.slsq(ii)) go to 140
      if(rsq.lt.srsq(ii)) go to 140
      d=(sqrt(rsq-persq(ii))-dlp(ii))/dist(ii,isub)
   20 y1=(yl(ii)-yr(ii))*d+yr(ii)
      x1=(xl(ii)-xr(ii))*d+xr(ii)
c  intersects in range
c          does circle (radius r) intersect it?
c        store first point
   30 npt=npt+1
      xc(npt)=x1
      yc(npt)=y1
      go to 140
c   closest point is at xl(ii),yl(ii)
   40 if(rsq.lt.slsq(ii)) go to 140
      if(rsq.gt.srsq(ii)) go to 140
   50 d=(sqrt(rsq-persq(ii))+dls(ii))/dist(ii,isub)
   60 x1=xl(ii)+(xr(ii)-xl(ii))*d
      y1=yl(ii)+(yr(ii)-yl(ii))*d
      go to 30
   70 if(rsq.lt.persq(ii)) go to 140
      if(rsq.le.slsq(ii)) go to 80
      if(rsq.gt.srsq(ii)) go to 140
c   single intersection
c     on side nearer xr,yr
      go to 50
   80 if(rsq.gt.srsq(ii)) go to 90
c     two intersections on this side
c    can compute angle directly without determining coordinates
      arg=abs(perp(ii))/r
      as=acos(arg)
      go to 100
   90 d=(dls(ii)-sqrt(rsq-persq(ii)) )/dist(ii,isub)
      go to 60
c    single intersection
c        see if this side is closest to point, if so, treat specially.
  100 if (ii-ics) 110,120,110
c          both points are on boundary, calculate angle betwen them.
  110 sign=-1.
      go to 130
  120 sign=1.
      signal=-1.
  130 angle=sign*2.*as + angle
c        see if second point only is on boundary
  140 continue
      if(npt.gt.0) go to 150
      if(signal) 310,320,320
  150 go to (320,240,160,250),npt
c     this is an error unless radius is on a vertex and
c      was counted twice.
  160 do 170 i=1,3
      j=jsub(i)
      if(abs(xc(i)-xc(j)) .ge. .01) go to 170
      if(abs(yc(i)-yc(j)) .le. .01) go to 220
  170 continue
c   check for one of three points being a vertex
      do 210 i=1,4
      do 180 j=1,3
      if(abs(xc(j)-xl(i)).gt. .001) go to 180
      if(abs(yc(j)-yl(i)) .le. .001) go to 190
  180 continue
      go to 210
  190 if(j-2) 200,200,230
  200 xc(j)=xc(3)
      yc(j)=yc(3)
      go to 230
  210 continue
      go to 320
  220 if(i.ne.1) go to 230
      xc(2)=xc(3)
      yc(2)=yc(3)
  230 npt=2
      go to 240
  240 ad=sqrt((xc(1)-xc(2))*(xc(1)-xc(2))+(yc(1)-yc(2))*(yc(1)-yc(2)))
      angle=angle + signal*2.*asin(ad/(2.*r))
      go to 310
c          four intersection points (each on a different side).
c          determine angle by finding closest 2 intersections to
c          farthest corner, calculate angle between, and add angle
c          between other two intersections.
  250 dist1=10000000.
      i1=0
      i2=0
      i3=0
      i4=0
      do 300 jj=1,4
      distn=(xl(ifar)-xc(jj))*(xl(ifar)-xc(jj))
     &  +(yl(ifar)-yc(jj))*(yl(ifar)-yc(jj))
      if (distn-dist1) 260,260,270
  260 dist2=dist1
      dist1=distn
      i4=i3
      i3=i2
      i2=i1
      i1=jj
      go to 300
  270 if (distn-dist2) 280,280,290
  280 dist2=distn
      i4=i3
      i3=i2
      i2=jj
      go to 300
  290 i4=i3
      i3=jj
  300 continue
c           calculate angle between 2 closest points to farthest corner.
      ad=sqrt((xc(i1)-xc(i2))*(xc(i1)-xc(i2))
     &  + (yc(i1)-yc(i2))*(yc(i1)-yc(i2)))
      angle=2.*asin(ad/(2.*r))
c         calculate angle between 2 points farthest from
c         farthest corner and add to previous angle.
      ad=sqrt((xc(i3)-xc(i4))*(xc(i3)-xc(i4))
     &  +(yc(i3)-yc(i4))*(yc(i3)-yc(i4)))
      angle=2.*asin(ad/(2.*r)) + angle
  310 continue
c        compute rate of earthquakes in this annular source
      return
c        error printout
  320 write(16,330)isub,ic,npt,xnot,ynot,(xl(i),yl(i), i=1,4),r,angle,
     &(xc(i),yc(i),i=1,4)
  330 format(' ***** error in subroutine outsid. source no.',i3,
     &' debug values follow.....',/10x,2i5,5(/10x,4f14.6))
  340 call exit
      end
