/*  relconm reads the output file risk.table from SEISRISK III (stdin)
and computes a table (stdout) showing the relative contribution
of the individual sources for each MEDIAN ATTENUATION acceleration 
exceedance level.
R. LaForge, 4/94,6/95,2/96 (with help from Greg LaCoste)
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

main(){
	char source[50][40];
	char line[110], ck[8], crp[8], dumsrc[12];
	float rp[50][200], exyr[50][200], con[50][200];
	float ac[200], totex[200],rpx;
	int n,i,imax=0,ns,k,m,nn,idum,p,nblocks;
	FILE *pts;
	pts=fopen("pts.relconm","w");

	printf("\nRelative Contributions to \
Median Attenuation Exceedance Levels\n");

/* read variable attenuation results */

	/* initialize arrays */

		for(i=1; i<200; i++)totex[i] = 0.;
		for(n=0; n<50; n++){
		for(i=0; i<200; i++){
			rp[n][i]=0.;
			exyr[n][i]=0.;
			con[n][i]=0.;
			}}

	/*   read input   */

	n=0;
	while(gets(line) != NULL){
		sprintf(source[n],"%s",line);      

	for(i=0; i<200; i++){
		gets(line);
		sscanf(line,"%f%*f%f%*f%f%*f%*f%*f%*f%*f",\
			 &ac[i],&exyr[n][i], &rp[n][i]);
		if(rp[n][i] > 99999.)break;
		}
			if(i > imax)imax=i;

		/*  skip to next source  */

			nn=0;
			while(nn == 0){
			gets(line);
			if(strchr(line, 'x'))nn=1;
				}
			n++;
		}    /*  end while loop  */

	/*  computation loop  */

		 ns=n-1;
       for(i=0; i< imax; i++){
		n=ns;
		while(n > -1){
			if(exyr[n][i] == 0.)n--;
			else {
			totex[i]=exyr[n][i];
			n=ns-1;
			break;
			}}
		while(n > -1){
			con[n+1][i] = (exyr[n+1][i]-exyr[n][i])/totex[i];
			n--;
			}
			con[0][i]=exyr[0][i]/totex[i];

		}  /* end for loop  */

	/* write to pts file */

	for(i=0; i<imax; i++){
		fprintf(pts,"%4.2f",ac[i]);
		for(k=0; k<=ns; k++)fprintf(pts," %5.3f",100*con[k][i]);
		fprintf(pts,"\n");
	}

	nblocks=(imax/15)+1;

	n=0; ac[imax]=0.;
	while(n<nblocks){

/*  print block header  */

	printf("\n");
	printf("Source\\PHA level              ");
	for(i=n*15; i<n*15+15; i++){
		char strng[5];
		sprintf(strng, "%.2f",ac[i]);
		strng[0] = ' ';
		printf("%s", strng);
		}
		printf("\n\n");

/*  print block  */

	for(k=0; k <= ns; k++){
	printf("%-.30s",source[k]);    
	for(m=n*15; m < n*15+15; m++){
		con[k][m] *= 100.;
		idum=con[k][m];
		idum=(con[k][m]-idum)<.5 ? idum : idum++;
		printf(" %3d",idum);       
		}
		printf("\n");
		}
		printf("\n\n");
n++;
}}
