c************************************************************
      subroutine spread(reg,jlo,ll,totac,dmid)
c     magnitude smoother for fault ruptures:
c     totac acceleration occurrences calculated for ruptures of
c     magnitude fm(ll) at distance dmid from site
c     are "spread" to acceleration levels corresponding
c     to magnitudes in the range
c     fm(ll)-delta/2 < fm(ll) < fm(ll)+delta/2
c     (where fm(ll-1)=fm(ll)-delta).
c     earthquake occurrences follow a Gutenberg-Richter
c     magnitude-frequency relationship, calculated from number
c     of earthquakes input at 2 successive magnitudes.
      common/magdis/jent,mdis
      common/rtb/rtab(20)
      dimension reg(106)
      common/accel/gm(25),exdif(101),atah(20,25),aclim(2)
      common/wds/max,maxp
      common/quad/maxq,ac(105),dumlog,aclog(105)
   10 continue
      if(dmid.eq.-1.) go to 60
      do 20 i=2,mdis
      if(dmid.le.rtab(i)) go to 40
   20 continue
c  distance exceeds table--we should not even be here
      write(16,30) dmid
   30 format(' in spread, dmid='e12.5' too large-should not be here')
      call exit
   40 fr=(rtab(i)-dmid)/(rtab(i)-rtab(i-1))
      ilim=1
      lp=ll+1
      do 50 lm=ll,lp
      aclim(ilim)=atah(i,lm)-fr*(atah(i,lm)-atah(i-1,lm))
   50 ilim=2
   60 acdif=aclim(2)-aclim(1)
      if(acdif.ne.0.) go to 90
      jbot=jlo+1
   70 if(aclog(jbot).le.aclim(1)) go to 80
      jbot=jbot-1
      if(jbot.ge.1) go to 70
   80 jup=jbot+1
      reg(jup)=reg(jup)+totac
      return
   90 add=0.
      jbot=jlo+1
  100 if(aclog(jbot).le.aclim(1)) go to 110
      jbot=jbot-1
      if(jbot.ge.1) go to 100
c    we are alower accel level--for lowest mag of range
  110 aclo=exdif(1)
      jup=jbot+1
  120 upl=aclog(jup)
      if(upl.gt.aclim(2)) upl=aclim(2)
      fr=(upl-aclim(1))/acdif
      iachi=100.*fr+1.00001
      quan=(+exdif(iachi)-aclo)*totac
      add=add+quan
      reg(jup)=reg(jup)+quan
      if(aclim(2).eq.upl) go to 130
      aclo=exdif(iachi)
      jup=jup+1
      if(jup.le.maxp) go to 120
      write(16,125)
  125 format(' spread routine needs higher acceleration level;'
     1/' rewrite BOX or increase scale factor')
      call exit
  130 continue
      return
      end
